#ifndef __QCONNECTION_H
#define __QCONNECTION_H


#include "qstring.h"
#include "qlist.h"

class QObject;

class QConnection
{
 protected:
  const QObject * m_Destination;
  QMember m_Member;
  QString m_strName;
  int m_nArgs;

 private:
  // someboday please tell me that under Qt there is a better way to 
  // count the args .. I feel like such a hack with the below.
  int countargs(const char * name)
    {
      int len = strlen(name);
      int nargs = 0;
      for(int i=0; i<len; i++) {
	if(name[i]==',')
	   nargs++;
      }
      
      return nargs;
    }

 public:
  QConnection(const QObject * p, QMember mem, const char * memberName) 
    { 
      m_Destination = p;
      m_Member = mem;
      m_strName = memberName;
      m_nArgs = countargs(memberName);
    }

  const QObject * object () const { return m_Destination; }
  const QString & name() const { return m_strName; }
  QMember * member() const { return &m_Member; }
  int numArgs() const { return m_nArgs; }

};

class QConnectionList : public QList<QConnection>
{
 public:
  QConnectionList() { };
};

class QConnectionListIt : public QList<QConnection>
{
 public:
  QConnectionListIt(const QListM_QConnection & list) { }
  operator++() { }
};

#define QConnectionDict QDict<QConnectionList>

#endif
