#ifndef __QMETAOBJECT
#define __QMETAOBJECT

#include "qstring.h"

class QObject;

typedef void (QObject::*QMember)();

struct QMetaData
{
  char * name;
  QMember ptr;
};

class QMetaObject
{
 protected:
  QMetaData * m_SlotData;
  QMetaData * m_SignalData;;
  int m_nSlots;
  int m_nSignals;

  QString m_strClassName;

 public:
  QMetaObject( const char *class_name, const char *superclass_name,
	       QMetaData *slot_data,  int n_slots,
	       QMetaData *signal_data, int n_signals )
    {
      m_SlotData = slot_data;
      m_SignalData = signal_data;
      m_nSlots = n_slots;
      m_nSignals = n_signals;
      m_strClassName = class_name;
    }

  QMember findsignal(const char * signal)
    {
      for(int i=0; i<m_nSignals; i++) {
	if(!strcmp(m_SignalData[i].name, signal+1))
	  return m_SignalData[i].ptr;
      }

      return 0;
    }

  QMember findslot(const char * slot)
    {
      for(int i=0; i<m_nSlots; i++) {
	if(!strcmp(m_SlotData[i].name, slot+1))
	  return m_SlotData[i].ptr;
      }

      return 0;
    }

};

#endif
