#ifndef __QPIXMAP_H
#define __QPIXMAP_H

#include "qstring.h"
#include "qpaintdevice.h"
#include "qsize.h"
#include "qbitmap.h"
#include "qwmatrix.h"


class QPixmap : public QPaintDevice
{
 protected:
  int m_nWidth;
  int m_nHeight;
  int m_nDepth;
  QBitmap * m_pBitmap;
  
  int m_nPix_W;
  int m_nPix_H;

  unsigned long m_Pixmap;
  unsigned long m_Mask;


 public:

  
  enum Optimization { DefaultOptim, NoOptim, MemoryOptim=NoOptim, 
		      NormalOptim, BestOptim };
  enum ColorMode { Auto,Color,Mono };
  
  QPixmap() { m_nWidth = 1; m_nHeight = 1; m_pBitmap = 0; }
  QPixmap(int w, int h, int depth=-1, Optimization = DefaultOptim) 
    { m_nWidth = w; m_nHeight = h; m_pBitmap = 0; }

  bool isNull() const {}
  
  int depth() const { return m_nDepth; }

  virtual void draw();

  int width() const { return m_nWidth; }
  int height() const { return m_nHeight; }

  bool loadFromData( const QByteArray & data, const char * format=0,
		     int conversion_flags=0);
  bool load ( const QString & fileName, 
	      const char * format=0, ColorMode mode=Auto );

  void resize(const QSize & qs) { }
  void resize(int width, int height) { }
  const QBitmap * mask() const { return m_pBitmap;}
  QPixmap xForm(const QWMatrix & matrix) const { return *this; }
};

#endif
